//Valida el formulari d'identificacio:
function validarFormulariIdentificacio()
{
	var errors = "";
	
	//Comprova les dades:
	var nom = trim(document.getElementById("nom").value);
	var clau = trim(document.getElementById("clau").value);

	if (nom == "") { errors += "\n* S'ha de ficar un nom d'usuari"; }
	if (clau == "") { errors += "\n* S'ha de ficar una clau"; }
	
	//Si han hagut errors, mostra el missatge pertinent:
	if (errors != "")
	{
		alert("Hi han hagut els seguents errors:\n" + errors);
	}
	
	//Retorna true o false segons les dades son valides o no:
	return (errors == "");
}


//Valida el formulari de registre:
function validarFormulariRegistre()
{
	var errors = "";
	
	//Comprova les dades:
	var nif = trim(document.getElementById("nif").value);
	var nom = trim(document.getElementById("nom_registre").value);
	var clau = trim(document.getElementById("clau_registre").value);
	var clauRepetida = trim(document.getElementById("clau_repetida").value);

	if (nif == "") { errors += "\n* S'ha de ficar un NIF"; }
	if (nom == "") { errors += "\n* S'ha de ficar un nom d'usuari"; }
	if (clau == "") { errors += "\n* S'ha de ficar una clau"; }
	if (clauRepetida == "") { errors += "\n* S'ha de ficar la clau repetida"; }
	if (clau != "" && clauRepetida != "" && clau != clauRepetida) { errors += "\n* La clau no coincideix al repetir-se"; }
	
	//Si han hagut errors, mostra el missatge pertinent:
	if (errors != "")
	{
		alert("Hi han hagut els seguents errors:\n" + errors);
	}
	
	//Retorna true o false segons les dades son valides o no:
	return (errors == "");
}


//Valida el formulari de cerca:
function validarFormulariCercar()
{
	var errors = "";
	
	//Comprova les dades:
	var zonaIndex = parseInt(document.getElementById("zones").selectedIndex);
	var tipus = trim(document.getElementById("tipus").value);
	var superficieMinima = trim(document.getElementById("superficie_minima").value);
	var preu = trim(document.getElementById("preu").value);

	if (zonaIndex < 0) { errors += "\n* S'ha de ficar, al menys, una zona"; }
	if (tipus == "") { errors += "\n* S'ha de ficar un tipus"; }
	if (superficieMinima == "" || isNaN(superficieMinima) || superficieMinima < 0) { errors += "\n* S'ha de ficar una superficie minima i ha de ser numeric superior o igual a 0"; }
	if (preu == "" || isNaN(preu) || preu < 0) { errors += "\n* El preu ha de ser numeric superior o igual a 0"; }

	//Si han hagut errors, mostra el missatge pertinent:
	if (errors != "")
	{
		alert("Hi han hagut els seguents errors:\n" + errors);
	}
	
	//Retorna true o false segons les dades son valides o no:
	return (errors == "");
}

//Demana confirmacio abans d'eliminar una cerca:
function confirmarEsborrarCerca()
{
	return (confirm("Estas segur de que vols eliminar la cerca?"));
}